```
                                 __           
  _____   _____     ____  ____  / /____  _____
 / ___/  / ___/    / __ \/ __ \/ __/ _ \/ ___/
/ /__   (__  )    / / / / /_/ / /_/  __(__  ) 
\___/  /____/    /_/ /_/\____/\__/\___/____/  
                                              
```

# CS notes

This is where I store notes about CS

___

## Lists
#### Needs more understandings #CS_list_need_understanding
```expander
tag:#CS_list_need_understanding 
- [ ] [[$filename]]
```
 
- [ ] [[Leetcode Binary-Tree-Preorder-Traversal]]
- [ ] [[Leetcode Implement-Queue-Using-Stacks]]
- [ ] [[Leetcode Reverse-Linked-List]]
- [ ] [[Leetcode Rotate-Array]]
 


#### Needs practicing #CS_list_need_practicing
```expander
tag:#CS_list_need_practicing 
- [ ] [[$filename]]
```
 
- [ ] [[Leetcode Binary-Search]]
- [ ] [[Leetcode Binary-Tree-Postorder-Traversal]]
- [ ] [[Leetcode Reverse-Linked-List]]
- [ ] [[Leetcode Rotate-Array]]
- [ ] [[Leetcode Validate-Binary-Search-Tree]]
 


## Websites

#### [leetcode.com](https://leetcode.com)

```expander
tag:#leetcode
- [[$filename]]
```
 
- [[Leetcode Best-Time-To-Buy-And-Sell-Stock]]
- [[Leetcode Binary-Search]]
- [[Leetcode Binary-Tree-Inorder-Traversal]]
- [[Leetcode Binary-Tree-Level-Order-Traversal]]
- [[Leetcode Binary-Tree-Postorder-Traversal]]
- [[Leetcode Binary-Tree-Preorder-Traversal]]
- [[Leetcode First-Bad-Version]]
- [[Leetcode First-Unique-Character-In-a-String]]
- [[Leetcode Implement-Queue-Using-Stacks]]
- [[Leetcode Insert-Into-a-Binary-Search-Tree]]
- [[Leetcode Intersection-of-Two-Arrays-II]]
- [[Leetcode Invert-Binary-Tree]]
- [[Leetcode Linked-List-Cycle]]
- [[Leetcode Lowest-Common-Ancestor-Of-a-Binary-Search-Tree]]
- [[Leetcode Maximum-Depth-Of-Binary-Tree]]
- [[Leetcode Maximum-Difference-Between-Increasing-Elements]]
- [[Leetcode Maxinum-subarray]]
- [[Leetcode Merge-Sorted-Array]]
- [[Leetcode Merge-Two-Sorted-Lists]]
- [[Leetcode Pascal's-Triangle]]
- [[Leetcode Path-Sum]]
- [[Leetcode Ransom-Note]]
- [[Leetcode Remove-Duplicates-From-Sorted-List]]
- [[Leetcode Remove-Linked-List-Elements]]
- [[Leetcode Reshape-The-Matrix]]
- [[Leetcode Reverse-Linked-List]]
- [[Leetcode Rotate-Array]]
- [[Leetcode Search-a-2D-Matrix]]
- [[Leetcode Search-In-a-Binary-Tree]]
- [[Leetcode Search-Insert-Position]]
- [[Leetcode Squares-of-a-Sorted-Array]]
- [[Leetcode Symmetric-Tree]]
- [[Leetcode Two-Sum]]
- [[Leetcode Two-Sum-IV-Input-Is-a-BST]]
- [[Leetcode Valid-Anagram]]
- [[Leetcode Valid-Parentheses]]
- [[Leetcode Valid-Sudoku]]
- [[Leetcode Validate-Binary-Search-Tree]]
 

 
#### [hackerearth.com](https://www.hackerearth.com/)

```expander
tag:#hackerearch
- [[$filename]]
```
 
 




___
## Data Structure
#### Coding problems
```expander
tag:#DS tag:#coding_problem -tag:#template_remove_me 
- [[$filename]]
```
 
- [[Leetcode Best-Time-To-Buy-And-Sell-Stock]]
- [[Leetcode Binary-Search]]
- [[Leetcode Binary-Tree-Inorder-Traversal]]
- [[Leetcode Binary-Tree-Level-Order-Traversal]]
- [[Leetcode Binary-Tree-Postorder-Traversal]]
- [[Leetcode Binary-Tree-Preorder-Traversal]]
- [[Leetcode First-Bad-Version]]
- [[Leetcode First-Unique-Character-In-a-String]]
- [[Leetcode Implement-Queue-Using-Stacks]]
- [[Leetcode Insert-Into-a-Binary-Search-Tree]]
- [[Leetcode Intersection-of-Two-Arrays-II]]
- [[Leetcode Invert-Binary-Tree]]
- [[Leetcode Linked-List-Cycle]]
- [[Leetcode Lowest-Common-Ancestor-Of-a-Binary-Search-Tree]]
- [[Leetcode Maximum-Depth-Of-Binary-Tree]]
- [[Leetcode Maxinum-subarray]]
- [[Leetcode Merge-Sorted-Array]]
- [[Leetcode Merge-Two-Sorted-Lists]]
- [[Leetcode Pascal's-Triangle]]
- [[Leetcode Path-Sum]]
- [[Leetcode Ransom-Note]]
- [[Leetcode Remove-Duplicates-From-Sorted-List]]
- [[Leetcode Remove-Linked-List-Elements]]
- [[Leetcode Reshape-The-Matrix]]
- [[Leetcode Reverse-Linked-List]]
- [[Leetcode Rotate-Array]]
- [[Leetcode Search-a-2D-Matrix]]
- [[Leetcode Search-In-a-Binary-Tree]]
- [[Leetcode Search-Insert-Position]]
- [[Leetcode Squares-of-a-Sorted-Array]]
- [[Leetcode Symmetric-Tree]]
- [[Leetcode Two-Sum]]
- [[Leetcode Two-Sum-IV-Input-Is-a-BST]]
- [[Leetcode Valid-Anagram]]
- [[Leetcode Valid-Parentheses]]
- [[Leetcode Valid-Sudoku]]
- [[Leetcode Validate-Binary-Search-Tree]]
 

 
#### Analysis
```expander
tag:#DS tag:#CS_analysis -tag:#template_remove_me 
- [[$filename]]
```
 
- [[Breadth First Search]]
- [[cpp_Range_based_for_loop]]
- [[cpp_std_multiset]]
- [[cpp_std_unordered_map]]
 

 
___
## Algorithm
#### Coding problems
```expander
tag:#algorithm tag:#coding_problem -tag:#template_remove_me 
- [[$filename]]
```
 
- [[Leetcode Best-Time-To-Buy-And-Sell-Stock]]
- [[Leetcode Binary-Search]]
- [[Leetcode Binary-Tree-Inorder-Traversal]]
- [[Leetcode Binary-Tree-Level-Order-Traversal]]
- [[Leetcode Binary-Tree-Postorder-Traversal]]
- [[Leetcode Binary-Tree-Preorder-Traversal]]
- [[Leetcode First-Bad-Version]]
- [[Leetcode First-Unique-Character-In-a-String]]
- [[Leetcode Insert-Into-a-Binary-Search-Tree]]
- [[Leetcode Intersection-of-Two-Arrays-II]]
- [[Leetcode Invert-Binary-Tree]]
- [[Leetcode Linked-List-Cycle]]
- [[Leetcode Lowest-Common-Ancestor-Of-a-Binary-Search-Tree]]
- [[Leetcode Maximum-Depth-Of-Binary-Tree]]
- [[Leetcode Maximum-Difference-Between-Increasing-Elements]]
- [[Leetcode Maxinum-subarray]]
- [[Leetcode Merge-Sorted-Array]]
- [[Leetcode Merge-Two-Sorted-Lists]]
- [[Leetcode Pascal's-Triangle]]
- [[Leetcode Path-Sum]]
- [[Leetcode Ransom-Note]]
- [[Leetcode Reverse-Linked-List]]
- [[Leetcode Rotate-Array]]
- [[Leetcode Search-a-2D-Matrix]]
- [[Leetcode Search-In-a-Binary-Tree]]
- [[Leetcode Search-Insert-Position]]
- [[Leetcode Squares-of-a-Sorted-Array]]
- [[Leetcode Symmetric-Tree]]
- [[Leetcode Two-Sum]]
- [[Leetcode Two-Sum-IV-Input-Is-a-BST]]
- [[Leetcode Valid-Anagram]]
- [[Leetcode Validate-Binary-Search-Tree]]
 



 
#### Analysis

```expander
tag:#algorithm tag:#CS_analysis -tag:#template_remove_me 
- [[$filename]]
```
 
- [[Binary Search Algorithm]]
- [[Breadth First Search]]
- [[cpp_std_sort]]
- [[Floyd's Cycle Finding Algorithm]]
- [[Kadane's Algorithm]]
- [[Two pointers approach]]
 


 